Index: ruby/trunk/lib/open_ehr/rm/data_types/quantity/date_time.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/data_types/quantity/date_time.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/data_types/quantity/date_time.rb	(revision 291)
@@ -0,0 +1,240 @@
+# This module is implementation of the UML:
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109696321450_28117_5362Report.html
+# Ticket refs #49
+require 'assumed_library_types'
+require 'date'
+
+module OpenEhr
+  module RM
+    module DataTypes
+      module Quantity
+        module DateTime
+          class DvTemporal < OpenEhr::RM::DataTypes::Quantity::DvAbsoluteQuantity
+            include Comparable
+            attr_reader :value
+
+            def initialize(value, magnitude_status=nil, accuracy=nil,
+                         normal_range=nil, normal_status=nil,
+                         other_reference_ranges=nil)
+              self.value = value
+              self.magnitude_status = magnitude_status
+              self.accuracy = accuracy
+              self.normal_range = normal_range
+              self.normal_status = normal_status
+              self.other_reference_ranges = other_reference_ranges
+            end
+
+            def value=(value)
+              if value.nil? or value.empty?
+                raise ArgumentError, 'invalid value'
+              end
+              @value = value
+            end
+
+            def <=>(other)
+              self.magnitude <=> other.magnitude
+            end
+          end
+
+          class DvDate < DvTemporal
+            include OpenEhr::AssumedLibraryTypes::ISO8601_DATE_MODULE
+
+            DAYS_IN_MONTH = [0,31,28,31,30,31,30,31,31,30,31,30,31]
+
+            def initialize(value, magnitude_status=nil, accuracy=nil,
+                           normal_range=nil, normal_status=nil,
+                           other_reference_range=nil)
+              super(value, magnitude_status, accuracy, normal_range,
+                    normal_status, other_reference_range)
+            end
+
+            def value=(value)
+              super(value)
+              iso8601_date = AssumedLibraryTypes::ISO8601_DATE.new(value)
+              @year = iso8601_date.year
+              @month = iso8601_date.month
+              @day = iso8601_date.day
+            end
+
+            undef magnitude=
+
+            def magnitude
+              return Date.new(@year, @month, @day)-Date.new(0000,1,1)
+            end
+
+            def diff(other)
+              if self.magnitude > other.magnitude
+                past, future = other, self
+              else
+                past, future = self, other
+              end
+              year, month, day = 0, 0, 0
+              if (future.day >= past.day)
+                day = future.day - past.day
+              else
+                month -= 1
+                previous_month = future.month - 1
+                if previous_month <= 0
+                  previous_month = 12
+                end
+                day = DAYS_IN_MONTH[previous_month] + future.day - past.day
+                if leapyear?(future.year) && (previous_month == 2)
+                  day += 1
+                end
+              end
+              week = day / 7
+              if (future.month >= past.month)
+                month += future.month - past.month
+              else
+                year -= 1
+                month += future.month + 12 - past.month
+              end
+              year += future.year - past.year
+              return DvDuration.new(
+                   'P' + year.to_s + 'Y' + month.to_s + 'M' + 
+                         week.to_s + 'W' + day.to_s + 'D')
+            end
+          end
+          
+          class DvTime < DvTemporal
+            include OpenEhr::AssumedLibraryTypes::ISO8601_TIME_MODULE
+            def initialize(value, magnitude_status=nil, accuracy=nil,
+                           normal_range=nil, normal_status=nil,
+                           other_reference_range=nil)
+              super(value, magnitude_status, accuracy, normal_range,
+                    normal_status, other_reference_range)
+            end
+
+            def value=(value)
+              super(value)
+              iso8601_time = AssumedLibraryTypes::ISO8601_TIME.new(value)
+              @hour = iso8601_time.hour
+              @minute = iso8601_time.minute
+              @second = iso8601_time.second
+              @fractional_second = iso8601_time.fractional_second
+            end
+
+            def magnitude
+              return @hour * 60 * 60 + @minute * 60 + @second + @fractional_second
+            end
+
+            def diff(other)
+              diff = (other.magnitude - self.magnitude).abs
+              hour = (diff / 60 / 60).to_i
+              minute = ((diff - hour*60*60)/60).to_i
+              second = (diff - hour * 60 *60 - minute * 60).to_i
+              fractional_second = ((diff - diff.to_i)*1000000.0).to_i/1000000.0
+              return DvDuration.new('P0Y0M0W0DT' + hour.to_s + 'H' +
+                        minute.to_s + 'M' +
+                        second.to_s + fractional_second.to_s[1..-1] + 'S')
+            end
+          end
+
+          class DvDateTime < DvTemporal
+            include OpenEhr::AssumedLibraryTypes::ISO8601_DATE_TIME_MODULE
+            attr_reader :value
+
+            def initialize(value, magnitude_status=nil, accuracy=nil,
+                           normal_range=nil, normal_status=nil,
+                           other_reference_range=nil)
+              super(value, magnitude_status, accuracy, normal_range,
+                    normal_status, other_reference_range)
+            end
+
+            def value=(value)              
+              super(value)
+              iso8601date_time = AssumedLibraryTypes::ISO8601_DATE_TIME.new(value)
+              self.year = iso8601date_time.year
+              self.month = iso8601date_time.month
+              self.day = iso8601date_time.day
+              self.minute = iso8601date_time.minute
+              self.second = iso8601date_time.second
+              self.hour = iso8601date_time.hour
+              self.fractional_second = iso8601date_time.fractional_second
+              self.timezone = iso8601date_time.timezone
+            end
+
+            def magnitude
+              seconds = DateTime.new(@year,@month,@day,@hour,@minute,@second) - 
+                DateTime.new(0000,1,1,0,0,0)
+              if @fractional_second.nil?
+                return seconds
+              else
+                return seconds + @fractional_second
+              end
+            end
+
+            undef magnitude=
+
+            def diff(other)
+              if self.magnitude >= other.magnitude
+                past, future = other, self
+              else
+                past, future = self, other
+              end
+              past_date, past_time = split_date_time(past)
+              future_date, future_time = split_date_time(future)
+              time_diff = future_time.magnitude - past_time.magnitude
+              if future_time.magnitude < past_time.magnitude
+                future_date.day = future_date.day - 1
+                time_diff += 24 * 60 * 60
+              end
+              date_duration = past_date.diff(future_date)
+              hour = (time_diff / 60 / 60).to_i
+              minute = ((time_diff - hour*60*60)/60).to_i
+              second = (time_diff - hour * 60 *60 - minute * 60).to_i
+              fractional_second = ((time_diff - time_diff.to_i)*1000000.0).to_i/1000000.0
+
+              return DvDuration.new(date_duration.value + 'T' +
+                        hour.to_s + 'H' +
+                        minute.to_s + 'M' +
+                        second.to_s + fractional_second.to_s[1..-1] + 'S')
+                                   
+            end
+
+            private
+
+            def split_date_time(date_time)
+              /^(.*)T(.*)$/ =~ date_time.as_string
+              return DvDate.new($1), DvTime.new($2)
+            end
+          end
+
+          class DvDuration < DvAmount
+            include AssumedLibraryTypes::ISO8601_DURATION_MODULE
+            attr_reader :value
+            
+            def initialize(value, magnitude_status=nil, accuracy=nil,
+                         accuracy_percent=nil, normal_range=nil,
+                         normal_status = nil, other_reference_ranges=nil)
+              self.value = value
+            end
+
+            def value=(value)
+              raise ArgumentError, 'value must be not nil' if value.nil?
+              @value = value
+              iso8601_duration = AssumedLibraryTypes::ISO8601_DURATION.new(value)
+              self.years = iso8601_duration.years
+              self.months = iso8601_duration.months
+              self.weeks = iso8601_duration.weeks
+              self.days = iso8601_duration.days
+              self.hours = iso8601_duration.hours
+              self.minutes = iso8601_duration.minutes
+              self.seconds = iso8601_duration.seconds
+              self.fractional_second = iso8601_duration.fractional_second
+            end
+
+            def magnitude
+              return ((((@year + @month/MONTH_IN_YEAR)*NOMINAL_DAYS_IN_MONTH) +
+                @week * DAYS_IN_WEEK + @days) * HOURS_IN_DAY * MINUTES_IN_HOUR*
+                SECONDS_IN_MINUTE) + @second + @fractional_second
+            end
+            
+            undef magnitude=
+
+          end
+        end # of DateTime
+      end # of Quantity
+    end # of Data_Types
+  end # of RM
+end # of OpenEHR
Index: ruby/trunk/lib/open_ehr/rm/data_types/text.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/data_types/text.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/data_types/text.rb	(revision 291)
@@ -0,0 +1,171 @@
+# This module implemented from this UML
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109067605961_209522_3179Report.html
+# Ticket refs #48
+module OpenEhr
+  module RM
+    module DataTypes
+      module Text
+        class TermMapping
+          attr_reader :match, :purpose, :target
+          def initialize(match, purpose, target)
+            match_valid(match)
+            purpose_valid(purpose)
+            target_valid(target)
+            @match, @purpose, @target = match, purpose, target
+          end
+          def broader?
+            match == '>'
+          end
+          def equivalent?
+            match == '='
+          end
+          def narrower?
+            match == '<'
+          end
+          def unknown?
+            match == '?'
+          end
+          def TermMapping.is_valid_mach_code?(c)
+            c == '>' or c == '=' or c == '<' or c == '?'
+          end
+          private
+          def match_valid(match)
+            raise ArgumentError, "match is not valid" if !TermMapping.is_valid_mach_code? match
+          end
+          def purpose_valid(purpose)
+            if purpose.nil? or !purpose.instance_of? DvCodedText
+              raise ArgumentError, "purpose is not valid"
+            end
+            # should be settled after terminology service implemented
+          end
+          def target_valid(target)
+            raise ArgumentError, "target must not be nil" if target.nil?
+          end
+        end
+
+        class CodePhrase
+          attr_reader :terminology_id, :code_string
+          def initialize(code_string, terminology_id)
+            self.code_string = code_string
+            self.terminology_id = terminology_id
+          end
+
+          def terminology_id=(terminology_id)
+            raise ArgumentError, "terminology_id should not be nil" if terminology_id.nil?
+            @terminology_id = terminology_id
+          end
+
+          def code_string=(code_string)
+            raise ArgumentError, "code_string should not be empty" if code_string.nil? or code_string.empty?
+            @code_string = code_string
+          end 
+        end # of CodePhrase
+
+        class DvText < OpenEhr::RM::DataTypes::Basic::DataValue
+          attr_reader :value, :formatting, :hyperlink, :mappings
+          attr_reader :language, :encoding
+          def initialize(value, formatting = nil, hyperlink = nil,
+                         mappings = nil, language = nil, encoding = nil)
+            value_valid(value)
+            DvText.formatting_valid(formatting)
+            DvText.encoding_valid(encoding)
+            DvText.mapping_valid(mappings)
+            DvText.language_valid(language)
+            @value, @formatting, @encoding = value, formatting, encoding
+            @mappings, @language = mappings, language
+          end
+          def value=(value)
+            value_valid(value)
+            @value = value
+          end
+          def formatting=(formatting)
+            DvText.formatting_valid(formatting)
+            @formatting = formatting
+          end
+          def encoding=(encoding)
+            DvText.encoding_valid(encoding)
+            @encoding = encoding
+          end
+          def mappings=(mappings)
+            DvText.mapping_valid(mappings)
+            @mappings = mappings
+          end
+          def language=(language)
+            DvText.language_valid(language)
+            @language = language
+          end
+          private
+          def value_valid(value)
+            if value.nil? or value.empty? or value.include? CR or value.include? LF
+              raise ArgumentError, "value is not valid"
+              # CR and LF are defined in Basic_Definition inherited DataValue.
+            end
+          end
+
+          class << self
+
+            def formatting_valid(formatting)
+              raise ArgumentError, "formatting is not valid" if formatting != nil and formatting.empty?
+            end
+
+            def encoding_valid(encoding)
+              raise ArgumentError, "encoding is not valid" if encoding != nil and encoding.empty?
+            end
+
+            def mapping_valid(mapping)
+              if !mapping.nil? and !mapping.instance_of? Set
+                raise ArgumentError, "mapping(s) is(are) not valid"
+              elsif !mapping.nil? and mapping.instance_of? Set
+                raise ArgumentError, "mapping(s) is(are) not valid" if mapping.empty? 
+              end
+            end
+
+            def language_valid(language)
+              raise ArgumentError, "langage is not valid" if language != nil and language.empty?
+            end
+          end
+
+        end
+
+        class DvCodedText < DvText
+          attr_reader :defining_code
+
+          def initialize(value, defining_code, formatting = nil, 
+                         hyperlink = nil, mappings = nil, language = nil, 
+                         encoding = nil)
+            super(value, formatting, hyperlink, mappings, language, encoding)
+            self.defining_code = defining_code
+          end
+
+          def defining_code=(defining_code)
+            if defining_code.nil?
+              raise ArgumentError, "Defiinition must be exist" 
+            end
+            @defining_code = defining_code
+          end
+        end
+
+        class DvParagraph < OpenEhr::RM::DataTypes::Basic::DataValue
+          attr_reader :items
+          def initialize(items)
+            items_exists(items)
+            @items = items
+          end
+          def items=(items)
+            items_exists(items)
+            @items = items
+          end
+          private
+          def items_exists(items)
+            if !items.nil? and !items.instance_of? Set
+              raise ArgumentError, "Items are not valid"
+            elsif !items.nil? and items.instance_of? Set
+              raise ArgumentError, "Items must be exist" if items.empty?
+            end
+          end
+        end
+
+      end # of Text
+    end # of DataTypes
+  end # of RM
+end # of OpenEHR
Index: ruby/trunk/lib/open_ehr/rm/data_types/time_specification.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/data_types/time_specification.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/data_types/time_specification.rb	(revision 291)
@@ -0,0 +1,75 @@
+# This module is related to the ticket #47
+
+module OpenEhr
+  module RM
+    module DataTypes
+      module TimeSpecification
+        class DvTimeSpecification < OpenEhr::RM::DataTypes::Basic::DataValue
+          attr_reader :value
+
+          def initialize(value)
+            self.value=(value)
+          end
+
+          def value=(value)
+            raise ArgumentError, 'value must be not nil' if value.nil?
+            @value = value
+          end
+          
+          def calender_alignment
+            raise NotImlementedError, "calender_alignment must be implemented"
+          end
+
+          def event_alignment
+            raise NotImlementedError, "event_alignment must be implemented"
+          end
+
+          def institution_specified
+            raise NotImlementedError, "institution_specified must be implemented"
+          end
+        end
+
+# I have not implemented two classes bellow,
+# because I could not obtain HL7 specification related them.
+
+
+        class DvGeneralTimeSpecification < DvTimeSpecification
+          attr_reader :value
+          def initialize(value)
+            super(value)
+          end
+          def value=(value)
+            raise ArgumentError, "value is not valied" unless value.formalism.is_equal?('HL7:GTS')
+            @value = value
+          end
+          private
+          def value_valid(value)
+          end
+        end
+
+        class DvPeriodicTimeSpecification < DvTimeSpecification
+          attr_reader :value, :calender_alignment, :event_alingment, :period
+          def initialize(value)
+            value_valid(value)
+            super(value)
+          end
+          def value=(value)
+            unless value.formalism.is_equal('HL7:PIVL') or value.formalism.is_equal('HL7:EIVL')
+              raise ArgumentError, "value is not valid"
+            end
+            if value.formalism('HL7:PIVL')
+              /^\[(\d+)\;?(\d+)?\]\/\((\d+\w+)\)(@(\w+?))?(IST)?$/ =~ value
+              interval1, interval2, difference, allignment = $1, $2, $3, $5
+            end
+            if value
+            end
+          end
+
+          def institution_specified?
+
+          end
+        end
+      end
+    end # of Data_Type
+  end # of RM
+end # of OpenEHR
Index: ruby/trunk/lib/open_ehr/rm/data_types/uri.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/data_types/uri.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/data_types/uri.rb	(revision 291)
@@ -0,0 +1,71 @@
+# This module is implemented from this UML:
+#http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109701308832_384250_6986Report.html
+# Ticket refs #46
+
+require 'uri'
+#require 'uri/generic'
+module Uri
+  class Ehr < ::URI::Generic
+    COMPONENT = [
+      :scheme, :path, :fragment, :query
+    ].freeze
+    def self.build(args)
+      tmp = Util::make_components_hash(self, args)
+      super(tmp)
+    end
+    def initialize(*arg)
+      super(*arg)
+    end
+    def self.use_registry
+      true
+    end
+  end
+  @@schemes['EHR'] = Ehr
+end
+
+module OpenEhr
+  module RM
+    module DataTypes
+      module Uri
+        class DvUri < OpenEhr::RM::DataTypes::Basic::DataValue
+          def initialize(value)
+            self.value = value
+          end
+          def fragment_id
+            @value.fragment
+          end
+          def path
+            @value.path
+          end
+          def query
+            @value.query
+          end
+          def scheme
+            @value.scheme
+          end
+          def value=(value)
+            raise ArgumentError, "value is empty" if value.nil?
+            parse(value)
+          end
+          def value
+            @value.to_s
+          end
+          private
+          def parse(value)
+            @value = ::URI.parse(value)
+          end
+        end
+
+        class DvEhrUri < DvUri
+          def initialize(value)
+            super(value)
+          end
+          def value=(value)
+            raise ArgumentError, "scheme must be ehr" if !(value =~ /^ehr/i)
+            parse(value)
+          end
+        end # of DV_EHR_URI
+      end # of URI
+    end # of DataTypes
+  end # of RM
+end # of OpenEHR
Index: ruby/trunk/lib/open_ehr/rm/demographic.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/demographic.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/demographic.rb	(revision 291)
@@ -0,0 +1,187 @@
+# This module is based on the UML,
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_5_76d0249_1118674798473_6021_0Report.html
+# Ticket refs #45
+module OpenEHR
+  module RM
+    module Demogrphic
+      class Address < OpenEHR::RM::Common::Archetyped::Locatable
+        attr_reader :details
+
+        def as_string
+
+        end
+
+        def type
+
+        end
+      end
+
+      class Capability < OpenEHR::RM::Common::Archetyped::Locatable
+        attr_reader :credentials, :time_validity
+
+      end
+
+      class Party < OpenEHR::RM::Common::Archetyped::Locatable
+        attr_reader :details, :reverse_relationships, :uid
+        attr_reader :idetities, :contacts, :relationships
+        def initialize(uid, archetype_node_id, name, archetype_details,
+                       feeder_audit, links, identities, contacts,
+                       relationships, reverse_relationships, details)
+          super(uid, archetype_node_id, name, archetype_details,
+                feeder_audit, links, nil)
+          uid_valid(uid)
+          @uid = uid
+          identities_vaild(identities)
+          @identities = identities
+          contacts_valid(contacts)
+          @contacts = contacts
+          relationships_valid(relationships)
+        end
+        def type
+          return name
+        end
+        def uid=(uid)
+          uid_valid(uid)
+          @uid = uid
+        end
+        def identities=(identities)
+          identities_vaild(identities)
+          @identities = identities
+        def contacts=(contacts)
+          contacts_valid(contacts)
+          @contacts = contacts
+        end
+        def parent=(parent)
+          @parent = nil
+        end
+        private
+        def uid_valid(uid)
+          raise ArgumentError, "uid is not valid" if uid.nil?
+        end
+        def identities_vaild(identities)
+          if identities.nil?
+            raise ArgumentError, "identities must not be nil"
+          elsif identities.empty?
+            raise ArgumentError, "identities must not be empty"
+          end
+        end
+        def contacts_valid(contacts)
+          if contacs.nil?
+            raise ArgumentError, "contacts must not be nil"
+          elsif contacts.empty?
+            raise ArgumentError, "contacts must not be empty"
+          end          
+        end
+      end
+
+      class PartyIdentity < OpenEHR::RM::Common::Archetyped::Locatable
+        attr_reader :details
+
+      end
+
+      class PartyRelationship < OpenEHR::RM::Common::Archetyped::Locatable
+
+      end
+
+      class Versioned_Party < OpenEHR::RM::Common::Archetyped::Locatable
+
+      end
+
+      class Role < Party
+
+      end
+
+      class Actor < Party
+        LEAGAL_IDENTITY = 'leagal identity'
+        attr_reader :languages, :rules
+        def initialize(uid, archetype_node_id, name, archetype_details,
+                       feeder_audit, links, identities, contacts,
+                       relationships, reverse_relationships, details,
+                       languages, rules)
+          super(uid, archetype_node_id, name, archetype_details,
+                feeder_audit, links, relationships, reverse_relationships,
+                details)
+          has_legal_identity?
+          set_languages(languages)
+          set_rules(rules)
+        end
+        def has_legal_identity?
+          @identities.each {|identity|
+            if (identity.purpose.value == LEAGAL_IDENTITY)
+              return true
+            end
+          }
+          false
+        end
+        def languages=(languages)
+          set_languages(languages)
+        end
+        def values=(values)
+          set_values(values)
+        end
+        private
+        def set_languages(languages)
+          if languages.nil?
+            raise ArgumentError, "languages should not be nil."
+          elsif languages.empty?
+            raise ArgumentError, "languages shouldnot be empty."
+          end
+          @languages = languages
+        end
+        def set_values(values)
+          if values.nil?
+            raise ArgumentError, "values should not be nil."
+          elsif values.empty?
+            raise ArgumentError, "values should not be nil."
+          end
+          @values = values
+      end
+      class Contact < OpenEHR::RM::Common::Archetyped::Locatable
+        attr_accessor :time_validity
+        attr_reader :addresses
+        def initialize(uid, archetype_node_id, name, archetype_details,
+                       feeder_audit, links, parent, time_validity, addresses)
+          super(uid, archetype_node_id, name, archetype_details,
+                feeder_audit, links, parent)
+          address_exists?(addresses)
+          @addresses = addresses
+          @time_validity = time_validity
+        end
+        def purpose
+          @name
+        end
+        def purpose=(purpose)
+          @name = purpose
+        end
+        def addresses=(addresses)
+          address_exists?(addresses)
+          @addresses = addresses
+        end
+        private
+        def address_exists?(addresses)
+          if addresses.nil?
+            raise ArgumentError, "address must not be nil"
+          elsif addresses.empty?
+            raise ArgumentError, "address must not be empty"
+          end
+        end
+      end
+
+      class Agent < Actor
+
+      end
+
+      class Organisation < Actor
+
+      end
+
+      class Person < Actor
+
+      end
+
+      class Group < Actor
+
+      end
+    end # of Demographic
+  end # of RM
+end # of OpenEHR
Index: ruby/trunk/lib/open_ehr/rm/security.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/security.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/security.rb	(revision 291)
@@ -0,0 +1,12 @@
+# This module is based on the UML,
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_5_1_76d0249_1155650882301_836618_5314Report.html
+# Ticket refs #41
+module OpenEhr
+  module RM
+    module Security
+      class AccessControlSettings
+        
+      end
+    end
+  end
+end
Index: ruby/trunk/lib/open_ehr/rm/support/assumed_types.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/support/assumed_types.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/support/assumed_types.rb	(revision 291)
@@ -0,0 +1,81 @@
+# Because his module utilise common methods in both rm
+# and am, I will integrated to /lib/models/assumed_types.rb.
+# By Shinji KOBAYASHI, 2008-07-20
+module OpenEhr
+  module RM
+    module Support
+      module AssumedTypes
+        class Interval
+          attr_accessor :lower, :upper
+#          attr_accessor :lower_included, :lower_unbounded
+#          attr_accessor :upper_included, :upper_unbounded
+          def initialize(lower, upper,
+                         lower_included = nil, upper_included = nil)
+            if ((lower !=nil) && (upper !=nil)) && lower>upper
+              raise ArgumentError, "upper < lower"
+            end
+            @lower = lower
+            @upper = upper
+          end
+        end
+
+        class List
+          attr_reader :content
+
+          def initialize(arg)
+            @content = arg
+          end
+
+          def first
+            @content.first
+          end
+
+          def last
+            @content.last
+          end
+        end
+
+        class TIME_DEFINITIONS
+        end
+
+
+        class ISO8601_DATE < TIME_DEFINITIONS
+        end
+
+        class ISO8601_TIME < TIME_DEFINITIONS
+        end
+
+        class ISO8601_DURATION < TIME_DEFINITIONS
+        end
+
+        class ISO8601_DATE_TIME < TIME_DEFINITIONS
+        end
+
+        class ISO8601_TIMEZONE < TIME_DEFINITIONS
+        end
+
+        class String
+          attr_reader :content
+          def initialize(arg)
+            @content = arg
+          end
+
+          def as_integer
+            is_integer if is_integer
+          end
+
+          def is_empty
+          end
+
+          def is_integer
+            begin
+              Integer(@content)
+            rescue
+              false
+            end
+          end
+        end
+      end
+    end
+  end
+end
Index: ruby/trunk/lib/open_ehr/rm/support/definition.rb
===================================================================
--- ruby/trunk/lib/open_ehr/rm/support/definition.rb	(revision 291)
+++ ruby/trunk/lib/open_ehr/rm/support/definition.rb	(revision 291)
@@ -0,0 +1,15 @@
+module OpenEhr
+  module RM
+    module Support
+      module Definition
+        module BasicDefinition
+          CR = "\015"
+          LF = "\012"
+        end
+        class OpenEHRDefinitions
+          include BasicDefinition
+        end
+      end
+    end
+  end
+end
